#include "extendable_polygon.hpp"

size_t ExtendablePolygon::numberOfPoints() const
{
    return polygon_.numberOfPoints();
}

Point & ExtendablePolygon::operator[](size_t index)
{
    return polygon_[index];
}

Point ExtendablePolygon::operator[](size_t index) const
{
    return polygon_[index];
}

void ExtendablePolygon::push(const Point& point)
{
    if (polygon_.isFull())
    {
        _extendMemorySize();
    }

    polygon_.push(point);
}

ExtendablePolygon::ExtendablePolygon(const Polygon & polygon, size_t polygon_size)
    : polygon_(polygon_size)
{
    for (size_t i = 0; i < polygon.numberOfPoints(); ++i)
    {
        polygon_.push(polygon[i]);
    }
}

void ExtendablePolygon::_extendMemorySize()
{
    *this = ExtendablePolygon(polygon_, polygon_.numberOfPoints() + increment_memory_size_);
}