#ifndef EXTENDED_POLYGON_HPP
#define EXTENDED_POLYGON_HPP

#include "Polygon.hpp"

class ExtendablePolygon
{
public:
    ExtendablePolygon() = default;

    void push(const Point&);
    size_t numberOfPoints() const;
    Point& operator[](size_t index);
    Point operator[](size_t index) const;

private:
    ExtendablePolygon(const Polygon&, size_t polygon_size);

    void _extendMemorySize();

    Polygon polygon_ = Polygon(0);
    static const size_t increment_memory_size_ = 2;
};

#endif // EXTENDED_POLYGON_HPP