#include <iostream> 
#include <random>

#include "extendable_polygon.hpp"

auto get_point()
{
    std::random_device rd;
    std::mt19937 gen(rd());
    std::uniform_real_distribution<> dis(-10.0, 10.0);

    return Point{ dis(gen), dis(gen) };
}

std::ostream& operator<<(std::ostream& os, const ExtendablePolygon& polygon)
{
    os << "number of points: " << polygon.numberOfPoints() << ", ";
    os << "points: ";

    for (auto i = 0; i < polygon.numberOfPoints(); ++i)
    {
        os << "<" << polygon[i].x << "," << polygon[i].y << ">";
    }
    return os;
}

auto get_random_polygon(size_t number_of_points)
{
    ExtendablePolygon polygon;

    for (size_t i = 0; i < number_of_points; i++)
    {
        polygon.push(get_point());
    }

    return polygon;
}

int main(void)
{
    auto polygon = get_random_polygon(4);
    std::cout << polygon << "\n";

    polygon.push(get_point());
    std::cout << polygon << "\n";

    getchar();
    return 0;
}

//int main(void)
//{
//    auto polygon = Polygon(2);
//    polygon.push(get_point()); // ok
//    polygon.push(get_point()); // ok
//    polygon.push(get_point()); // blad
//
//    getchar();
//    return 0;
//}
