#ifndef POLYGON_HPP
#define POLYGON_HPP

#include <iostream>

struct Point
{
    double x, y;
};

class Polygon
{
public:
    Polygon(size_t size);
    Polygon(const Polygon&);
    Polygon(Polygon&&);

    Polygon& operator=(const Polygon&);
    Polygon& operator=(Polygon&&);

    void push(Point);
    bool isFull();

    size_t numberOfPoints() const;
    Point& operator[](size_t index);
    Point operator[](size_t index) const;

    ~Polygon();

private:
    Polygon() = default;
    Polygon(size_t size, size_t number_of_points);

    void swap(Polygon&, Polygon&);

    size_t size_ = 0;
    size_t number_of_points_ = 0;
    Point* points_ = nullptr;
};

#endif // POLYGON_HPP